<?php
session_start();
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;
use Slim\Factory\AppFactory;

require __DIR__ . '/../vendor/autoload.php';

$app = AppFactory::create();

function addNavBar($response) 
{

	$response->getBody()->write('<html><head><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/water.css"></head><body>');
	if (isset($_SESSION['username'])) {
			$response->getBody()->write('<div><a href="/">Index</a> | <a href="/blog/create">Create Blog</a> | <a href="/logout">Logout</a></div>');
	} else {
			$response->getBody()->write('<div><a href="/">Index</a> | <a href="/login">Login</a></div>');
	}
	return;
}

function addFooter($response) 
{
	$response->getBody()->write('<div>Privacy statement | Cookie Policy | Contact</div>');
	$response->getBody()->write("</body></html>");
	return;
}

function init()
{
    $art1 = ["slug" => "artikel-1", "title" => "Dit is titel 1", "content" => "Lorem ipsum 1"];
    $art2 = ["slug" => "artikel-2", "title" => "Dit is titel 2", "content" => "Lorem ipsum 2"];
    $art3 = ["slug" => "artikel-3", "title" => "Dit is titel 3", "content" => "Lorem ipsum 3"];
    $art4 = ["slug" => "artikel-4", "title" => "Dit is titel 4", "content" => "Lorem ipsum 4"];
    $_SESSION['blogs'] = [$art1, $art2, $art3, $art4];
}


$app->get('/', function (Request $request, Response $response, array $args) {
	init();
	addNavBar($response);

	$response->getBody()->write('<hr/><h1>Onze Blog</h1>');

	$response->getBody()->write('<ul>');

	foreach ($_SESSION['blogs'] as $art)
	{
		$response->getBody()->write('<li><a href="/blog/' . $art['slug'] . '">' . $art['title'] . '</a></li>');
	}

	$response->getBody()->write('</ul>');

	$response->getBody()->write('<hr/>');

	addFooter($response);

	
	return $response;
});

$app->get('/blog/{slug}', function (Request $request, Response $response, array $args) {

	addNavBar($response);
	foreach ($_SESSION['blogs'] as $art) {
		if ($art['slug'] == $args['slug']) {
				$response->getBody()->write("<h1>" . $art['title'] . "</h1>");
		}
}
	addFooter($response);

	return $response;
});

$app->get('/logout', function (Request $request, Response $response, array $args) {
	unset($_SESSION['username']);
	addNavbar($response);
	$response->getBody()->write('Logged out');
	addFooter($response);
	return $response->withHeader('Location', '/')->withStatus(302);;
});


$app->map(['GET','POST'],'/login', function (Request $request, Response $response, array $args) {

	if ($request->getMethod()=='GET')
	{
	addNavBar($response);
	$response->getBody()->write('<form action=/login method="POST">');
	$response->getBody()->write('<label for="username">Username:</label>');
	$response->getBody()->write('<input type="text" name="username"/><br/>');
	$response->getBody()->write('<label for="password">Password:</label>');
	$response->getBody()->write('<input type="password" name="password"/><br/>');
	$response->getBody()->write('<input type="submit"/>');
	$response->getBody()->write('');
	$response->getBody()->write('</form>');
	addFooter($response);
	} else {
		$postdata =$request->getParsedBody();
		if($postdata['username']== 'gebruiker' && $postdata['password'] == 'abcd')
		{
		
		$_SESSION["username"] = $postdata['username'];
		addNavbar($response);
		$response->getBody()->write('Logged in');
		addFooter($response);
		} else {
			$response->getBody()->write('Username and/or password are incorrect');
		}
	}
	return $response;
});

$app->post('/postcomment', function (Request $request, Response $response, array $args) {
	$response->getBody()->write("Post comment");
	return $response;
});

$app->post('/blog/create', function (Request $request, Response $response, array $args) {
	$response->getBody()->write("Blog create");
	return $response;
});

$app->run();